/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest{}

// AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest struct for AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest
type AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest struct {
	Service *string                             `json:"service,omitempty"`
	Data    *GoogleAnalyticsStaticDtoAuthorizer `json:"data,omitempty"`
}

// NewAppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest instantiates a new AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest() *AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest {
	this := AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest{}
	var service string = "google_analytics_static"
	this.Service = &service
	return &this
}

// NewAppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequestWithDefaults instantiates a new AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequestWithDefaults() *AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest {
	this := AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest{}
	var service string = "google_analytics_static"
	this.Service = &service
	return &this
}

// GetService returns the Service field value if set, zero value otherwise.
func (o *AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest) GetService() string {
	if o == nil || IsNil(o.Service) {
		var ret string
		return ret
	}
	return *o.Service
}

// GetServiceOk returns a tuple with the Service field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest) GetServiceOk() (*string, bool) {
	if o == nil || IsNil(o.Service) {
		return nil, false
	}
	return o.Service, true
}

// HasService returns a boolean if a field has been set.
func (o *AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest) HasService() bool {
	if o != nil && !IsNil(o.Service) {
		return true
	}

	return false
}

// SetService gets a reference to the given string and assigns it to the Service field.
func (o *AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest) SetService(v string) {
	o.Service = &v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest) GetData() GoogleAnalyticsStaticDtoAuthorizer {
	if o == nil || IsNil(o.Data) {
		var ret GoogleAnalyticsStaticDtoAuthorizer
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest) GetDataOk() (*GoogleAnalyticsStaticDtoAuthorizer, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given GoogleAnalyticsStaticDtoAuthorizer and assigns it to the Data field.
func (o *AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest) SetData(v GoogleAnalyticsStaticDtoAuthorizer) {
	o.Data = &v
}

func (o AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Service) {
		toSerialize["service"] = o.Service
	}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	return toSerialize, nil
}

type NullableAppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest struct {
	value *AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest
	isSet bool
}

func (v NullableAppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest) Get() *AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest {
	return v.value
}

func (v *NullableAppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest) Set(val *AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest(val *AppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest) *NullableAppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest {
	return &NullableAppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest{value: val, isSet: true}
}

func (v NullableAppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerGoogleAnalyticsStaticGoogleAnalyticsStaticAuthorizerNewRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
